#
# Makefile for mod_owa.so
#
.SUFFIXES:
.SUFFIXES:		.lc .oc .lpc .opc .pc .c .o .cpp .oln

ORA_LIB         = $(ORACLE_HOME)/lib
APACHE_TOP      = /usr/local/apache2/src

ORAINC          = -I$(ORACLE_HOME)/rdbms/demo \
		  -I$(ORACLE_HOME)/rdbms/public \
		  -I$(ORACLE_HOME)/network/public
INCLUDES        = -I. $(ORAINC) -I$(APACHE_TOP)/os/unix \
		  -I$(APACHE_TOP)/include \
		  -I$(APACHE_TOP)/srclib/apr/include \
		  -I$(APACHE_TOP)/srclib/apr-util/include

CC              = cc
LD              = cc
CFLAGS          = -DAPACHE20 -DLINUX -Wall -O
LDFLAGS         = -shared

CLIBS           = -L/usr/lib -ldl -lpthread -lc

ORALINK         = -L$(ORACLE_HOME)/lib -lclntsh

OBJS            = owautil.o owafile.o owanls.o owasql.o \
                  owadoc.o owahand.o owaplsql.o owacache.o modowa.o

mod_owa.so: $(OBJS)
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(ORALINK) $(CLIBS)

.c.o:
	$(CC) $(CFLAGS) $(INCLUDES) -c $<
