#
# Makefile for mod_owa.so
#
.SUFFIXES:
.SUFFIXES:		.lc .oc .lpc .opc .pc .c .o .cpp .oln

ORA_LIB         = $(ORACLE_HOME)/lib
APACHE_TOP      = /usr/local/apache/src

ORAINC          = -I$(ORACLE_HOME)/rdbms/demo \
		  -I$(ORACLE_HOME)/rdbms/public \
		  -I$(ORACLE_HOME)/network/public
INCLUDES        = -I. -I$(APACHE_TOP)/os/unix -I$(APACHE_TOP)/include $(ORAINC)

CC              = cc
LD              = ld
CFLAGS          = -Xa -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -xstrconst -DSUN_OS5 -O
LDFLAGS         = -G

CLIBS           = -L/usr/lib -ldl -lpthread -lc

ORALINK         = -L$(ORACLE_HOME)/lib -lclntsh

OBJS            = owautil.o owafile.o owanls.o owasql.o \
                  owadoc.o owahand.o owaplsql.o owacache.o

mod_owa.so: modowa.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ modowa.o $(OBJS) $(ORALINK) $(CLIBS)

.c.o:
	$(CC) $(CFLAGS) $(INCLUDES) -c $<
